"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const test_1 = require("@oclif/test");
const fs = require("fs");
const path = require("path");
require("chai");
describe('swagger-ui', () => {
    test_1.test
        .stdout()
        .command(['swagger-ui', path.join('examples', 'openapi.yml')])
        .it('runs swagger-ui', (ctx) => {
        test_1.expect(ctx.stdout).to.contain('running');
    });
    test_1.test
        .stdout()
        .command(['swagger-ui', path.join('examples', 'openapi.yml'), '--bundle', 'static'])
        .it('bundles swagger-ui', (ctx) => {
        test_1.expect(fs.existsSync(path.join('static')));
        test_1.expect(fs.existsSync(path.join('static', 'index.html')));
        test_1.expect(fs.existsSync(path.join('static', 'openapi.json')));
        test_1.expect(fs.existsSync(path.join('static', 'swagger-ui.js')));
    });
    afterEach(() => {
        // emit disconnect to stop the server
        process.emit('disconnect');
    });
});
