"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const test_1 = require("@oclif/test");
const path = require("path");
require("chai");
describe('swagger2openapi', () => {
    test_1.test
        .stdout()
        .command(['swagger2openapi', path.join('examples', 'swagger.json')])
        .it('converts json swagger to openapi v3', (ctx) => {
        test_1.expect(ctx.stdout).to.contain('openapi: 3');
        test_1.expect(ctx.stdout).to.contain('My API');
    });
    test_1.test
        .stdout()
        .command(['swagger2openapi', path.join('examples', 'swagger.yml')])
        .it('converts yaml swagger to openapi v3', (ctx) => {
        test_1.expect(ctx.stdout).to.contain('openapi: 3');
        test_1.expect(ctx.stdout).to.contain('My API');
    });
    test_1.test
        .stdout()
        .command(['swagger2openapi', path.join('examples', 'swagger.json'), '--json'])
        .it('converts swagger to openapi v3 json', (ctx) => {
        test_1.expect(ctx.stdout).to.contain('{');
        test_1.expect(ctx.stdout).to.contain('"openapi": "3');
        test_1.expect(ctx.stdout).to.contain('My API');
        test_1.expect(ctx.stdout).to.contain('}');
    });
});
