"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
exports.help = (overrides = {}) => ({
    help: command_1.flags.help(Object.assign({ char: 'h' }, overrides)),
});
exports.servers = () => ({
    server: command_1.flags.string({
        char: 'S',
        description: 'add servers to definition',
        helpValue: 'http://localhost:9000',
        multiple: true,
    }),
});
exports.parseOpts = () => (Object.assign({ dereference: command_1.flags.boolean({ char: 'D', description: 'resolve $ref pointers' }), validate: command_1.flags.boolean({ char: 'V', description: 'validate against openapi schema' }) }, exports.servers()));
exports.serverOpts = () => ({
    port: command_1.flags.integer({
        char: 'p',
        description: 'port',
        default: 9000,
        helpValue: '9000',
    }),
    logger: command_1.flags.boolean({
        description: '[default: true] log requests',
        default: true,
        allowNo: true,
    }),
});
exports.outputFormat = () => ({
    format: command_1.flags.enum({
        char: 'f',
        description: '[default: yaml] output format',
        options: ['json', 'yaml', 'yml'],
        exclusive: ['json', 'yaml'],
    }),
    json: command_1.flags.boolean({ description: 'format as json (short for -f json)', exclusive: ['format', 'yaml'] }),
    yaml: command_1.flags.boolean({ description: 'format as yaml (short for -f yaml)', exclusive: ['format', 'json'] }),
});
exports.swaggerUIOpts = () => ({
    expand: command_1.flags.string({
        description: '[default: list] default expansion setting for the operations and tags',
        options: ['full', 'list', 'none'],
    }),
    operationids: command_1.flags.boolean({ description: '[default: true] display operationIds', default: true, allowNo: true }),
    filter: command_1.flags.boolean({ description: '[default: true] enable filtering by tag', default: true, allowNo: true }),
    deeplinks: command_1.flags.boolean({ description: '[default: true] allow deep linking', default: true, allowNo: true }),
    withcredentials: command_1.flags.boolean({
        description: '[default: true] send cookies in "try it now"',
        default: true,
        allowNo: true,
    }),
    requestduration: command_1.flags.boolean({
        description: '[default: true] display request durations in "try it now"',
        default: true,
        allowNo: true,
    }),
});
