import * as Koa from 'koa';
import { Document } from 'swagger-parser';
export declare const swaggerUIRoot: string;
export declare enum DocExpansion {
    Full = "full",
    List = "list",
    None = "none"
}
export interface SwaggerUIOpts {
    url?: string;
    spec?: Document;
    deepLinking?: boolean;
    docExpansion?: DocExpansion;
    displayOperationId?: boolean;
    displayRequestDuration?: boolean;
    showExtensions?: boolean;
    showCommonExtensions?: boolean;
    withCredentials?: boolean;
    filter?: boolean | string;
    layout?: string;
}
export declare function serveSwaggerUI(opts?: SwaggerUIOpts): Koa<any, {}>;
export declare function getSwaggerUIIndexHTML(opts?: SwaggerUIOpts): string;
